#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
// Simulates 1 overdamped particle in a harmonic potential
//
//
// HEUN______________________
// uses ran2 valid until 10^18 calls


float gasdev(long *idum);
void clear_kb(void);
double fuerza_potencial(double x,double x0,double U0);
double medir_la_posicion(double x,double sigmam,long *idum);

long N; //Number of particles. N=1 in this problem
int junk;

int main(void)
{
long *semilla,entero,i,j,k,l,numciclos,indice,r,numrealizaciones;
long particula; // counter for particles. Not actually needed as N=1 for this problem
double Dt;
double t;

//parameters for expansion and measurement
long Ntau;//Number of time steps between two measurements

long Nexp;//Number of time steps for an expansion
long Nm;//Number of measurements before an expansion is performed

double sigmam; //measurement error (standard deviation of q(m|x))
double m; //measurement outcome
//long Nexpansion;//numero de pasos de expansin
double W;//Total performed work (extracted if negative)


int pinta; //For checking if output should be produced.
//Model parameters
double alpha;//Viscosity of the medium. Not used
double D; //Diffusion coefficient
//Potential parameters
double kappa;//Stiffness V=1/2 kappa*x^2;
double kappa0;//initial kappa at the beginning of expansion
double Dkappa;//kappa steps for expansion, one Dkappa for one time step

//---------------- Data input--------------------
printf("\n %%Generated with tweezer_confinement_expansion.cc");
N=1;
double *x,xmedia=0;  //particle postion and average
double x0=0;//initial trap position
double x_std=0; //stores x dispersion
double *x_pred; //used for Heun's algorithm

double *fuerza;   //force on particles

double *fuerza_pred; //For heun's 
double z; //Gaussian random number
//Memory allocation
if ((x=(double *)malloc(N*sizeof(double)))==NULL)
        {
        printf("\n No hay memoria para asignar 'x'.");
        exit(1);
        }
if ((x_pred=(double *)malloc(N*sizeof(double)))==NULL)
        {
        printf("\n No hay memoria para asignar 'x'.");
        exit(1);
        }
if ((fuerza=(double *)malloc(N*sizeof(double)))==NULL)
        {
        printf("\n No hay memoria para asignar 'fuerza'.");
        exit(1);
        }
if ((fuerza_pred=(double *)malloc(N*sizeof(double)))==NULL)
        {
        printf("\n No hay memoria para asignar 'fuerza'.");
        exit(1);
        }
//Data input is done on the keyboard

printf("\n %%Time step:  ");
junk=scanf("%lf",&Dt);
clear_kb();
printf(" %lf",Dt);
printf("\n %%Cicle number:");
junk=scanf("%ld",&numciclos);
clear_kb();
printf(" %ld",numciclos);
printf("\n %%Number of steps between measurements:");
junk=scanf("%ld",&Ntau);
clear_kb();
printf(" %ld",Ntau);
printf("\n %%Number of measurements between expansions:");
junk=scanf("%ld",&Nm);
clear_kb();
printf(" %ld",Nm);
printf("\n %%Number of time steps in an expansion:");
junk=scanf("%ld",&Nexp);
clear_kb();
printf(" %ld",Nexp);
printf("\n %%Diffusion coefficient D:  ");
junk=scanf("%lf",&D);
clear_kb();
printf(" %lf",D);
printf("\n %%kappa for the tweezer:  ");
junk=scanf("%lf",&kappa);
clear_kb();
printf(" %lf",kappa);
kappa0=kappa;
printf("\n %%Measurement error (sigma_m):  ");
junk=scanf("%lf",&sigmam);
clear_kb();
printf(" %lf",sigmam);

printf("\n %%Number of realizations:");
junk=scanf("%ld",&numrealizaciones);
clear_kb();
printf(" %ld",numrealizaciones);

printf("\n %%Random number seed (negative):");
junk=scanf("%ld",&entero);
clear_kb();
printf(" %ld",entero);

printf("\n %%---Output---\n %% t x m x0 kappa W ");  //print output
if (fflush(stdout))
	{
	printf("\n Error al vaciar buffer");
	}



//-----------------------------------------------------


semilla=&entero;

for (r=0;r<numrealizaciones;r++) //all simulations have been done with 1 realization and many expansion cycles
{
t=0.0;
xmedia=0;
for (i=0;i<N;i++)  
	{
	//x[i]=0;
	//We start in equilibrium
	z=gasdev(semilla);
	x[i]=x0+z*sqrt(D/kappa0);
	xmedia+=x[i];
	}
	xmedia=xmedia/N;
	//m=0; 
	m=medir_la_posicion(xmedia,sigmam,semilla); //first measurement (0th in fact)
        printf("\n %lf %.4lf %.4lf %.4lf %.4lf %.4lf",t,xmedia,m,x0,kappa,0.0);  //print output
        if (fflush(stdout))
                {
                printf("\n Error al vaciar buffer");
                }


for (i=0;i<numciclos;i++)  // cycle for
	{
	  printf("\n %%Starting a cycle");
	  W=0; //We store every cycle Work separately
	  for (j=0;j<Nm;j++) //Measurements
	  	{	  
	  	for (k=0;k<Ntau;k++) //Ntau steps between measurements
	    		{
			xmedia=0.0;
			for (particula=0;particula<N;particula++) //1 particle only
				{
				//Move particle according to Langevin, during normal evolution between measurements
				z=gasdev(semilla);
		        	fuerza[particula]=fuerza_potencial(x[particula],x0,kappa);
				//----Predictor--------
				x_pred[particula]=x[particula]+(fuerza[particula]*Dt+z*sqrt(2*D*Dt));
				fuerza_pred[particula]=fuerza_potencial(x_pred[particula],x0,kappa);
				//----Corrector--------
				//v[particula]=(Dt*.5*(fuerza[particula]+fuerza_pred[particula])+z*sqrt(2*D*Dt))/alpha/Dt;
				x[particula]=x[particula]+(Dt*.5*(fuerza[particula]+fuerza_pred[particula])+z*sqrt(2*D*Dt));
				xmedia+=x[particula];  //average. N=1, so coincides with particle position
				//printf("  x[%ld]=%lf",particula,x[particula]);
				}
			t+=Dt;
			xmedia=xmedia/N;
			printf("\n %lf %.4lf %.4lf %.4lf %.4lf %.4lf",t,xmedia,m,x0,kappa,W);  //print output
		
			if (fflush(stdout))
				{
				printf("\n Error al vaciar buffer");
				}

			} 		
	  	//Next: measure postition, change kappa and trap position (feedback)
		m=medir_la_posicion(xmedia,sigmam,semilla);
		printf("\n %%Measuring!");
		//Update trap and compute total work performed
		W-=0.5*(xmedia-x0)*(xmedia-x0)*kappa; //Substract potential energy on current position on old potential
		x0=(pow(sigmam,2)*x0+D/kappa*m)/(pow(sigmam,2)+D/kappa); //New trap postition
		Dkappa=D/pow(sigmam,2); 
		kappa=kappa+Dkappa;//New kappa
		//Add energy of new trap to work. So that work is the difference in energy in the new trap- energy in old trap
		//We use xmedia, but there is only one particle.
		W+=0.5*(xmedia-x0)*(xmedia-x0)*kappa;
		} //for j < Nm
 //We have finished the measurements steps. Now expand	
	printf("\n %%Expansion!!"); //Marks expansion beginning in output
	Dkappa=(kappa-kappa0)/Nexp;  //kappa steps in expansion
	for (l=0;l<Nexp;l++)
	  	{
		//Move particle according to Langevin equation also during expansion
			xmedia=0.0;
			for (particula=0;particula<N;particula++) //
				{
				z=gasdev(semilla);
		        	fuerza[particula]=fuerza_potencial(x[particula],x0,kappa);
				//----Predictor--------
				x_pred[particula]=x[particula]+(fuerza[particula]*Dt+z*sqrt(2*D*Dt));
				fuerza_pred[particula]=fuerza_potencial(x_pred[particula],x0,kappa);
				//----Corrector--------
				x[particula]=x[particula]+(Dt*.5*(fuerza[particula]+fuerza_pred[particula])+z*sqrt(2*D*Dt));
				xmedia+=x[particula];  //only 1 particle, stores postion of the particle in xmedia
				}
			t+=Dt;
			xmedia=xmedia/N; //N=1;
			printf("\n %lf %.4lf %.4lf %.4lf %.4lf %.4lf",t,xmedia,m,x0,kappa,W);  //print output
			if (fflush(stdout))
				{
				printf("\n Error al vaciar buffer");
				}

		
		//Update kappa
		kappa=kappa-Dkappa;
		//Compute performed work in expansion
		W+=-Dkappa*0.5*(xmedia-x0)*(xmedia-x0);

		}
	} //cycle for ends
} //realization for ends (just 1 realization anyway)
printf("\n");


} //end of main 

double fuerza_potencial(double x,double x0,double U0)
{
// Computes force due to tweezer potential
double f;
f=-U0*(x-x0);
return f;
}

double medir_la_posicion(double x,double sigmam,long *idum)
{
  //produces measurement output according to q(m|x)
double z;
double m;
z=gasdev(idum); //Gaussian number of zero mean and 1 std dev
//printf("\n x=%lf",x);
m=x+sigmam*z; //measurement outcome 
return m;
}

void clear_kb(void)
  {
  char junk[80];
  char *basura;
  basura=fgets(junk,79,stdin);
  }

